part of picsou_simulation;

class SimulationEurl {

  Logger logger = new Logger('picsou.SimulationEurl');

  double turnover;
  double runningCost;

  Remuneration remuneration;
  double impotIs;
  Dividend dividend;

  double ir;
  double net;

  double treso;

  SimulationEurl(this.turnover, this.runningCost, this.remuneration,
      this.impotIs, this.dividend, this.ir, this.net, this.treso);

  Map toPublicJson() {
    Map map = new Map();
    map["turnover"] = roundNumber(turnover);
    map["runningCost"] = roundNumber(runningCost);
    map["remuneration"] = remuneration.toPublicJson();
    map["is"] = roundNumber(impotIs);
    map["dividend"] = dividend.toPublicJson();
    map["treso"] = roundNumber(treso);
    map["ir"] = roundNumber(ir);
    map["net"] = roundNumber(net);
    map["pourcentageNet"] = roundNumber(net / (turnover - runningCost) * 100);

    return map;
  }

  String toString() {
    return """
      \n
      [SimulationEurl]
      turnover = $turnover
      runningCost = $runningCost
      remunerationEurl = $remuneration
      impotIs = $impotIs
      dividend = $dividend
      ir = $ir
      net = $net
      """;
  }
}
