part of picsou_simulation;


abstract class ChargeSas implements ComputeSas {

  Logger logger = new Logger('picsou.ChargeEurl');

  String name;
  double tauxSalarial;
  double tauxPatronal;

  ChargeSas(this.name, this.tauxSalarial, this.tauxPatronal);

  String toString() {
    return """
      \n
      [ChargeSas]
      name = $name
      tauxSalarial = $tauxSalarial
      tauxPatronal = $tauxPatronal
      """;
  }
}

abstract class ComputeSas {
  double computeSalariale(double amount);
  double computePatronale(double amount);
}

class ChargeSasComputed {

  Logger logger = new Logger('picsou.ChargeSasComputed');

  ChargeSas charge;
  double partSalarialeComputed;
  double partPatronaleComputed;

  ChargeSasComputed(this.charge, this.partSalarialeComputed, this.partPatronaleComputed);

  Map toPublicJson() {
    Map map = new Map();
    map["name"] = charge.name;
    map["partSalariale"] = roundNumber(partSalarialeComputed);
    map["partPatronale"] = roundNumber(partPatronaleComputed);

    return map;
  }

  String toString() {
    return """
      \n
      [ChargeSasComputed]
      charge = $charge
      partSalarialeComputed = $partSalarialeComputed
      partPatronaleComputed = $partPatronaleComputed
      """;
  }
}
