part of picsou_simulation;

class Salary {

  Logger logger = new Logger('picsou.SalarySas');

  double chargesSalariales;
  double chargesPatronales;

  double extraGrossSalary;
  double grossSalary;
  double netSalary;
  double netImposable;

  List<ChargeSasComputed> chargesComputed = new List();

  Salary.computeFromCharges(double grossSalary, List<ChargeSasComputed> chargesComputed) {
    this.grossSalary = grossSalary;
    this.chargesComputed = chargesComputed;

    chargesSalariales = 0.00;
    chargesPatronales = 0.00;
    for(ChargeSasComputed chargeComputed in this.chargesComputed) {
      chargesSalariales += chargeComputed.partSalarialeComputed;
      chargesPatronales += chargeComputed.partPatronaleComputed;
    }

    netSalary = this.grossSalary - chargesSalariales;

    List<ChargeSasComputed> chargesComputedNonDeductibles = chargesComputed.where((ChargeSasComputed chargeSasComputed) {
      if(chargeSasComputed.charge is ChargeSasCsgCrds) {
        ChargeSasCsgCrds charge = chargeSasComputed.charge;
        if(charge.isDeductible == false) {
          return true;
        }
      }
      return false;
    }).toList();

    double sumChargesIndeductible = chargesComputedNonDeductibles.map((charge) => charge.partSalarialeComputed).reduce((charge1, charge2) => charge1 + charge2);
    netImposable = netSalary + sumChargesIndeductible;

    extraGrossSalary = this.grossSalary + chargesPatronales;
  }

  Map toPublicJson() {
    Map map = new Map();
    map["gross"] = roundNumber(grossSalary);
    map["net"] = roundNumber(netSalary);
    map["extraGross"] = roundNumber(extraGrossSalary);
    map["netImposable"] = roundNumber(netImposable);

    List charges = new List();
    for(ChargeSasComputed charge in chargesComputed) {
      charges.add(charge.toPublicJson());
    }

    map["charges"] = charges;

    return map;
  }

  String toString() {
    return """
      \n
      [Salary]
      grossSalary = $grossSalary
      netSalary = $netSalary
      netImposable = $netImposable
      extraGrossSalary = $extraGrossSalary
      chargesSalariales = $chargesSalariales
      chargesPatronales = $chargesPatronales
      """;
  }
}
