part of picsou_simulation;


ServiceIrIs serviceIrIs = new ServiceIrIs();

class ServiceIrIs {

  Logger logger = new Logger('picsou.ServiceIrIs');

  double computeIr(double amount) {

    List<SeuilIr> seuils = [new SeuilIr(0.00, 9700.00, 0.00),
                            new SeuilIr(9700.00, 26791.00, 14.00),
                            new SeuilIr(26791.00, 71826.00, 30.00),
                            new SeuilIr(71826.00, 152108.00, 41.00),
                            new SeuilIr(152108.00, null, 45.00)];

    double ir = 0.00;

    for(SeuilIr seuil in seuils) {

      if(amount > seuil.seuil1 && seuil.seuil2 == null) {
        ir += ((amount - seuil.seuil1) * seuil.taux) / 100;

      } else if(amount > seuil.seuil1 && amount >= seuil.seuil2) {
        ir += ((seuil.seuil2 - seuil.seuil1) * seuil.taux) / 100;

      } else if(amount > seuil.seuil1 && amount < seuil.seuil2) {
        ir += ((amount - seuil.seuil1) * seuil.taux) / 100;
      }
    }

    return ir;
  }

  double computeIs(double profit) {

    double taux1 = 15.00;
    double seuil = 38120.00;
    double taux2 = 33.00;

    double charges = 0.00;
    if(profit <= seuil) {
      charges = profit * taux1 / 100;
    }

    if(profit > seuil) {
      charges = (seuil * taux1 / 100) + ((profit - seuil) * taux2 / 100);
    }

    return charges;
  }
}

class SeuilIr {

  double seuil1;
  double seuil2;
  double taux;

  SeuilIr(this.seuil1, this.seuil2, this.taux);
}

